ies = []
ies.append({ "ie_type" : "F-SEID", "ie_value" : "CP F-SEID", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if the CP function decides to change its F-SEID for the PFCP session. The UP function shall use the new CP F-SEID for subsequent PFCP Session related messages for this PFCP Session. See Note 2."})
type_list["Remove PDR"]["max_tlv_more"] = "15"
ies.append({ "ie_type" : "Remove PDR", "ie_value" : "Remove PDR", "presence" : "C", "tlv_more" : "15", "comment" : "When present, this IE shall contain the PDR Rule which is requested to be removed. See Table 7.5.4-6-1.Several IEs within the same IE type may be present to represent a list of PDRs to remove."})
type_list["Remove FAR"]["max_tlv_more"] = "15"
ies.append({ "ie_type" : "Remove FAR", "ie_value" : "Remove FAR", "presence" : "C", "tlv_more" : "15", "comment" : "When present, this IE shall contain the FAR Rule which is requested to be removed. See Table 7.5.4-7-1.Several IEs within the same IE type may be present to represent a list of FARs to remove."})
type_list["Remove URR"]["max_tlv_more"] = "15"
ies.append({ "ie_type" : "Remove URR", "ie_value" : "Remove URR", "presence" : "C", "tlv_more" : "15", "comment" : "When present, this shall contain the URR Rule which is requested to be removed. See Table 7.5.4-8-1.Several IEs within the same IE type may be present to represent a list of URRs to remove."})
type_list["Remove QER"]["max_tlv_more"] = "3"
ies.append({ "ie_type" : "Remove QER", "ie_value" : "Remove QER", "presence" : "C", "tlv_more" : "3", "comment" : "When present, this IE shall contain the QER Rule which is requested to be removed. See Table 7.5.4-9-1.Several IEs within the same IE type may be present to represent a list of QERs to remove."})
ies.append({ "ie_type" : "Remove BAR", "ie_value" : "Remove BAR", "presence" : "C", "tlv_more" : "0", "comment" : "When present, this IE shall contain the BAR Rule which is requested to be removed. See Table 7.5.4.12-1."})
ies.append({ "ie_type" : "Remove Traffic Endpoint", "ie_value" : "Remove Traffic Endpoint", "presence" : "C", "tlv_more" : "0", "comment" : "When present, this IE shall contain the Traffic Endpoint ID identifying the traffic endpoint to be removed, if the UP function has indicated support of PDI optimization.All the PDRs that refer to the removed Traffic Endpoint shall be deleted.See Table 7.5.4.14-1.Several IEs within the same IE type may be present to represent a list of Traffic Endpoints to remove."})
ies.append({ "ie_type" : "Create PDR", "ie_value" : "Create PDR", "presence" : "C", "tlv_more" : "15", "comment" : "This IE shall be present if the CP function requests the UP function to create a new PDR.See Table7.5.2.2-1.Several IEs within the same IE type may be present to represent a list of PDRs to create."})
ies.append({ "ie_type" : "Create FAR", "ie_value" : "Create FAR", "presence" : "C", "tlv_more" : "15", "comment" : "This IE shall be present if the CP function requests the UP function to create a new FAR. See Table 7.5.2.3-1.Several IEs within the same IE type may be present to represent a list of FARs to create."})
ies.append({ "ie_type" : "Create URR", "ie_value" : "Create URR", "presence" : "C", "tlv_more" : "15", "comment" : "This IE shall be present if the CP function requests the UP function to create a new URR. See Table 7.5.2.4-1.Several IEs within the same IE type may be present to represent a list of URRs to create."})
ies.append({ "ie_type" : "Create QER", "ie_value" : "Create QER", "presence" : "C", "tlv_more" : "3", "comment" : "This IE shall be present if the CP function requests the UP function to create a new QER. See Table 7.5.2.5-1.Several IEs within the same IE type may be present to represent a list of QERs to create."})
ies.append({ "ie_type" : "Create BAR", "ie_value" : "Create BAR", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if the CP function requests the UP function to create a new BAR.See Table 7.5.2.6-1."})
ies.append({ "ie_type" : "Create Traffic Endpoint", "ie_value" : "Create Traffic Endpoint", "presence" : "C", "tlv_more" : "0", "comment" : "When present this IE shall contain the information associated with the Traffic Endpoint to be created, if the UP function has indicated support of PDI optimization. See Table 7.5.2.7-1.Several IEs within the same IE type may be present to represent a list of Traffic Endpoints to create."})
type_list["Update PDR"]["max_tlv_more"] = "15"
ies.append({ "ie_type" : "Update PDR", "ie_value" : "Update PDR", "presence" : "C", "tlv_more" : "15", "comment" : "This IE shall be present if a PDR previously created for the PFCP session need to be modified.See Table7.5.4.2-1.Several IEs within the same IE type may be present to represent a list of PDRs to update."})
type_list["Update FAR"]["max_tlv_more"] = "15"
ies.append({ "ie_type" : "Update FAR", "ie_value" : "Update FAR", "presence" : "C", "tlv_more" : "15", "comment" : "This IE shall be present if a FAR previously created for the PFCP session need to be modified. See Table 7.5.4.3-1. Several IEs within the same IE type may be present to represent a list of FARs to update."})
type_list["Update URR"]["max_tlv_more"] = "15"
ies.append({ "ie_type" : "Update URR", "ie_value" : "Update URR", "presence" : "C", "tlv_more" : "15", "comment" : "This IE shall be present if URR(s) previously created for the PFCP session need to be modified.Several IEs within the same IE type may be present to represent a list of modified URRs. Previously URRs that are not modified shall not be included.See Table7.5.4.4-1."})
type_list["Update QER"]["max_tlv_more"] = "3"
ies.append({ "ie_type" : "Update QER", "ie_value" : "Update QER", "presence" : "C", "tlv_more" : "3", "comment" : "This IE shall be present if QER(s) previously created for the PFCP session need to be modified.Several IEs within the same IE type may be present to represent a list of modified QERs.Previously created QERs that are not modified shall not be included.See Table 7.5.4.5-1."})
ies.append({ "ie_type" : "Update BAR Session Modification Request", "ie_value" : "Update BAR", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if a BAR previously created for the PFCP session needs to be modified.A previously created BAR that is not modified shall not be included.See Table 7.5.4.11-1."})
ies.append({ "ie_type" : "Update Traffic Endpoint", "ie_value" : "Update Traffic Endpoint", "presence" : "C", "tlv_more" : "0", "comment" : "When present this IE shall contain the information associated with the traffic endpoint to be updated, if the UP function has indicated support of PDI optimization.All the PDRs that refer to the Traffic Endpoint shall use the updated Traffic Endpoint information.See Table 7.5.4.13-1.Several IEs within the same IE type may be present to represent a list of Traffic Endpoints to update."})
ies.append({ "ie_type" : "PFCPSMReq-Flags", "ie_value" : "PFCPSMReq-Flags", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be included if at least one of the flags is set to 1.-	DROBU (Drop Buffered Packets): the CP function shall set this flag if the UP function is requested to drop the packets currently buffered for this PFCP session (see NOTE 1).-	QAURR (Query All URRs): the CP function shall set this flag if the CP function requests immediate usage report(s) for all the URRs previously provisioned for this PFCP session (see NOTE 3).-	SUMPC (Stop Usage Measurement to Pause Charging): the CP function, e.g. PGW-C or (H-)SMF, shall set this flag if the usage measurement for the URRs which are applicable for charging (i.e. with the ASPOC flag set to 1) shall be stopped in the UP function.-	RUMUC (Resume Usage Measurement to Un-pause Charging): the CP function, e.g. PGW-C or (H-)SMF, shall set this flag if the usage measurement for the URRs which are applicable for charging (i.e. with the ASPOC flag set to 1) shall be resumed in the UP function. -	DETEID (Delete All DL N3mb and/or N19mb F-TEIDs): the MB-SMF shall set this flag to 1 if it requests the MB-UPF to delete all NG-RAN N3mb DL F-TEIDs and all UPF N19mb DL F-TEIDs for the MBS session when the Apply Action is changed from the FSSM and/or MBSU to the BUFF (with or without NOCP), or to DROP (see clause 5.34.2.4)."})
ies.append({ "ie_type" : "Query URR", "ie_value" : "Query URR", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if the CP function requests immediate usage report(s) to the UP function.Several IEs within the same IE type may be present to represent a list of URRs for which an immediate report is requested.See Table 7.5.4.10-1.See NOTE 3."})
ies.append({ "ie_type" : "FQ-CSID", "ie_value" : "PGW-C/SMF FQ-CSID", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be included according to the requirements in clause23 of 3GPPTS23.007[24] and clause4.6 of 3GPPTS23.527[40]."})
ies.append({ "ie_type" : "FQ-CSID", "ie_value" : "SGW-C FQ-CSID", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be included according to the requirements in clause23 of 3GPPTS23.007[24]."})
ies.append({ "ie_type" : "FQ-CSID", "ie_value" : "MME FQ-CSID", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be included according to the requirements in clause23 of 3GPPTS23.007[24]."})
ies.append({ "ie_type" : "FQ-CSID", "ie_value" : "ePDG FQ-CSID", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be included according to the requirements in clause23 of 3GPPTS23.007[24]."})
ies.append({ "ie_type" : "FQ-CSID", "ie_value" : "TWAN FQ-CSID", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be included according to the requirements in clause23 of 3GPPTS23.007[24]."})
ies.append({ "ie_type" : "User Plane Inactivity Timer", "ie_value" : "User Plane Inactivity Timer", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if it needs to be changed."})
ies.append({ "ie_type" : "Query URR Reference", "ie_value" : "Query URR Reference", "presence" : "O", "tlv_more" : "0", "comment" : "This IE may be present if the Query URR IE is present or the QAURR flag is set to 1. When present, it shall contain a reference identifying the query request, which the UP function shall return in any usage report sent in response to the query."})
ies.append({ "ie_type" : "Trace Information", "ie_value" : "Trace Information", "presence" : "O", "tlv_more" : "0", "comment" : "When present, this IE shall contain the trace instructions to be applied by the UP function for this PFCP session.A Trace Information with a null length indicates that the trace session shall be deactivated. "})
ies.append({ "ie_type" : "Remove MAR", "ie_value" : "Remove MAR", "presence" : "C", "tlv_more" : "0", "comment" : "When present, this IE shall contain the MAR Rule which is requested to be removed. See Table 7.5.4.15-1.Several IEs within the same IE type may be present to represent a list of MARs to remove."})
ies.append({ "ie_type" : "Update MAR", "ie_value" : "Update MAR", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if an MAR previously created for the PFCP session needs to be modified.See Table7.5.4.16-1.Several IEs within the same IE type may be present to represent a list of MARs to update."})
ies.append({ "ie_type" : "Create MAR", "ie_value" : "Create MAR", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if the CP function requests the UP function to create a new MAR for a new PDR. See Table 7.5.2.8-1.Several IEs within the same IE type may be present to represent a list of MARs to create."})
ies.append({ "ie_type" : "Node ID", "ie_value" : "Node ID", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if a new SMF in an SMF Set, with one PFCP association per SMF and UPF (see clause5.22.3), takes over the control of the PFCP session.When present, it shall contain the unique identifier of the new SMF."})
ies.append({ "ie_type" : "TSC Management Information IE within PFCP Session Modification Request", "ie_value" : "TSC Management Information", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if the SMF needs to send TSC Management information to the UPF.Several IEs within the same IE type may be present to transfer PMICs for different NW-TT ports. (NOTE6)."})
ies.append({ "ie_type" : "Remove SRR", "ie_value" : "Remove SRR", "presence" : "C", "tlv_more" : "0", "comment" : "When present, this shall indicate the SRR Rule which is requested to be removed. See Table7.5.4-19-1.Several IEs within the same IE type may be present to represent a list of SRRs to remove."})
ies.append({ "ie_type" : "Create SRR", "ie_value" : "Create SRR", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if the CP function requests the UP function to create a new SRR. See Table 7.5.2.9-1.Several IEs within the same IE type may be present to represent a list of SRRs to create."})
ies.append({ "ie_type" : "Update SRR", "ie_value" : "Update SRR", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if SRR(s) previously created for the PFCP session need to be modified.Several IEs within the same IE type may be present to represent a list of modified SRRs. Previously SRRs that are not modified shall not be included. SeeTable7.5.4.20-1."})
ies.append({ "ie_type" : "Provide ATSSS Control Information", "ie_value" : "Provide ATSSS Control Information", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present for PFCP session modification for an MA PDU session, if the ATSSS Control Information changes.When present, this IE shall contain the required ATSSS functionalities for this MA PDU session.The UPF shall replace any value received previously by the new information received in this IE. See Note4.See Table7.5.2.10-1."})
ies.append({ "ie_type" : "Ethernet Context Information", "ie_value" : "Ethernet Context Information", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present to update the list of MAC addresses associated to the PDU session during an Ethernet PDU session anchor relocation. "})
ies.append({ "ie_type" : "Access Availability Information", "ie_value" : "Access Availability Information", "presence" : "O", "tlv_more" : "0", "comment" : "This IE may be present for an MA PDU session to signal that an access type has become transiently unavailable or has become available again (see clause5.20.5).Two IEs with the same IE type may be present to report changes of access availability for both 3GPP and non-3GPP accesses."})
ies.append({ "ie_type" : "Query Packet Rate Status IE within PFCP Session Modification Request", "ie_value" : "Query Packet Rate Status", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if the CP function requests immediate packet rate status report(s) to the UP function.Several IEs within the same IE type may be present to represent a list of QERs for which an immediate packet rate status report is requested.See Table7.5.4.22-1."})
ies.append({ "ie_type" : "S-NSSAI", "ie_value" : "S-NSSAI", "presence" : "O", "tlv_more" : "0", "comment" : "This IE may be present to indicate the S-NSSAI of the PDU session or MBS session, if the S-NSSAI of the PDU Session or MBS session has been provided previously to the UP function and the S-NSSAI has changed. (NOTE5)"})
ies.append({ "ie_type" : "RAT Type", "ie_value" : "RAT Type", "presence" : "", "tlv_more" : "0", "comment" : "This IE shall be present if there is a RAT change and the CP function wants to inform the UP Function about the new RAT Type if the PFCP session is not established for a MA PDU session."})
ies.append({ "ie_type" : "Group ID", "ie_value" : "Group Id", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be included by the CP function to indicate the new group identifier to which the PFCP session pertains, if it has been changed (see clause5.22.4).When present, the UP function shall replace any earlier value associated to the PFCP session with the new value."})
ies.append({ "ie_type" : "MBS Session N4 Control Information", "ie_value" : "MBS Session N4 Control Information", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be included if: -	the correspond PDU session is being associated with an MBS session, or with an MBS session and Area Session ID for a location dependent MBS service; or -	the PDU session is already associated with an MBS session, or with an MBS session and Area Session ID for a location dependent MBS service, and the N19mb multicast transport information has changed. In this case, the Multicast Transport Information IE shall contain the new multicast transport information to use to receive MBS session data from the MB-UPF.Several IEs with the same IE type may be present to provide N4 control information for several MBS sessions, e.g. when the UE requests to join several MBS sessions.See Table7.5.2.1-5 for encoding."})
ies.append({ "ie_type" : "DSCP to PPI Control Information", "ie_value" : "DSCP to PPI Control Information", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if the DSCP to PPI Control Information needs to be changed. The UPF shall replace any value received previously by the new information received in this IE.See Table7.5.2.1-6 for encoding."})
msg_list[key]["ies"] = ies
